! #######################################################
!            Satellite Data Simulation Unit
!          -  The beam convolution program -
!
!  This program applies beam convolution to simulated output.
!
!               Updated from BEAM-SIM.f by H. M. (May, 2009)
! --------------------------------------------------------
 Program BEAM_SIM
   Use MAINparameters
   Use BMCVparameters
   Implicit NONE
!
   Integer :: ifile
!
! - Sensor parameters and running options
!
   Call param_set
!
   Call param_set_bmcv
!
! - Input file list
!
   Call def_file_list ( CRM_file_list )
!
! - Beam convolution begins
!
   Do ifile = 1 , nmodel
!
      print *, 'Input: '//CRM_file_list(ifile)(1:18)
!
! ###########################################################
!                --- Microwave Radiometer ---
! ###########################################################
!
      If ( microw ) then
!
! - Read in the original-resolution data
!
         Call in_micro_bmcv  ( ifile )
!
! - Beam convolution
!
         Call convolv_micro
!
! - Write out
!
         Call out_micro_bmcv ( ifile )
!
      Endif
!
! ###########################################################
!                         --- Radar ---
! ###########################################################
!
      If ( radar ) then
!
! - Read in the original-resolution data
!
         Call in_radar_bmcv  ( ifile )
!
! - Beam convolution
!
         Call convolv_radar
!
! - Write out
!
         Call out_radar_bmcv ( ifile )
!
      Endif
!
! ###########################################################
!                   --- Vis/IR Radiometer ---
! ###########################################################
!
      If ( visIR ) then
!
! - Read in the original-resolution data
!
         Call in_visir_bmcv  ( ifile )
!
! - Beam convolution
!
         Call convolv_visir
!
! - Write out
!
         Call out_visir_bmcv ( ifile )
!
      Endif
!
   End do
!
 End Program BEAM_SIM

